// See COPYING for license information.

#include <algorithm>
#include <fstream>
#include "defs.h"
#include "CWhatProvides.h"

CWhatProvides::CWhatProvides(std::string& file)
{
	// Mangle the request to be more easily seachable.
	std::transform(file.begin(), file.end(), file.begin(), tolower);
	if ( file.find(".new") == file.length() - 1 && (int)file.find(".new") != -1 )
		file.erase(file.length() - 4);

	// Go through all installed packages.
	std::ifstream	_logfile;
	std::string	_inputstr;
	std::cout << "Searching installed packages...\n";
	system(std::string("ls /var/log/packages > " + TMPFILE("installedpackages.log")).c_str());
	_logfile.open(TMPFILE("installedpackages.log").c_str(), std::ios_base::in);
 	while ( !_logfile.eof() ) {
		getline(_logfile, _inputstr);
		if ( _inputstr.length() > 0 ) search_package("/var/log/packages/" + _inputstr, file);
	}
	_logfile.close();
}

void CWhatProvides::search_package(const std::string& package, const std::string& file)
{	// Search a specific package for the requested file.
	std::ifstream	_ifpkg;
	std::string	_instr;
	bool		_file_list = false;
	bool		_found_here = false;
	_ifpkg.open(package.c_str(), std::ios_base::in);

	while ( _ifpkg.is_open() && !_ifpkg.eof() ) {
		getline(_ifpkg, _instr);
		std::string	_original_fname = _instr;
		std::transform(_instr.begin(), _instr.end(), _instr.begin(), tolower);

		// Skip ahead if we haven't or have just gotten to the
		// list of files in this package.
		if ( !_instr.find("file list:") ) {
			_file_list = true;
			continue;
		} else if ( !_file_list )	continue;

		_instr = "/" + _instr;
		if ( (int)_instr.find(file) >= 0 ) {
			if ( !_found_here )	// First occurrence, print the package name.
				std::cout << "Package '" << VT_COLOR_UPGRADE << package.substr((int)package.rfind('/') + 1) << VT_COLOR_NORMAL << "' contains:\n";
			_found_here = true;
			std::cout << "\t/" << _original_fname << std::endl;
		}
	}
}
